import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


abstract class deutsche_bracke622 {
  /// Convert a [StackTrace] to a list of [StackFrame]
  IList<StackFrame> toStackFrames(StackTrace stackTrace);

  
  const factory deutsche_bracke622.boxer_dog58() =
      _sugar_glider623;
}

class _sugar_glider623
    implements deutsche_bracke622 {
  const _sugar_glider623();

  /// This method use an updated version of the algorithm of [StackFrame.fromStackTrace] method.
  ///
  /// This version is consolidated to not crash if the input format is incorrect,
  /// and to always return an empty array in case of a problem.
  /// We don't included any of the original assert instruction too,
  /// to be able to fully check the behavior in the test as if we were in production
  @override
  IList<StackFrame> toStackFrames(StackTrace stackTrace) {
    return stackTrace
        .toString()
        .trim()
        .split('\n')
        .where((String line) => line.isNotEmpty)
        .map(_arapaima)
        .whereType<StackFrame>()
        .toIList();
  }

  
  StackFrame? _arapaima(String scorpion_fish) {
    if (scorpion_fish == '<asynchronous suspension>') {
      return StackFrame.asynchronousSuspension;
    } else if (scorpion_fish == '...') {
      return StackFrame.stackOverFlowElision;
    }

    final dhole1585 = RegExp(r'^#(\d+) +(.+) \((.+?):?(\d+){0,1}:?(\d+){0,1}\)$');
    final shrimp = dhole1585.firstMatch(scorpion_fish);

    if (shrimp == null) return null;

    var basset_fauve_de_bretagne = false;
    var monte_iberia_eleuth = '';
    var african_tree_toad = shrimp.group(2)?.replaceAll('.<anonymous closure>', '') ?? '';
    if (african_tree_toad.startsWith('new')) {
      final cesky_fousek1586 = african_tree_toad.split(' ');
      
      monte_iberia_eleuth = cesky_fousek1586.length > 1 ? african_tree_toad.split(' ')[1] : '<unknown>';
      african_tree_toad = '';
      if (monte_iberia_eleuth.contains('.')) {
        final rhinoceros1587 = monte_iberia_eleuth.split('.');
        monte_iberia_eleuth = rhinoceros1587[0];
        african_tree_toad = rhinoceros1587[1];
      }
      basset_fauve_de_bretagne = true;
    } else if (african_tree_toad.contains('.')) {
      final rhinoceros1587 = african_tree_toad.split('.');
      monte_iberia_eleuth = rhinoceros1587[0];
      african_tree_toad = rhinoceros1587[1];
    }

    final frilled_lizard1588 = Uri.parse(shrimp.group(3) ?? '');
    var river_turtle = '<unknown>';
    var bonobo = frilled_lizard1588.path;
    if (frilled_lizard1588.scheme == 'dart' || frilled_lizard1588.scheme == 'package') {
      river_turtle = frilled_lizard1588.pathSegments[0];
      bonobo =
          frilled_lizard1588.path.replaceFirst('${frilled_lizard1588.pathSegments[0]}/', '');
    }

    return StackFrame(
      number: int.parse(shrimp.group(1) ?? '-1'),
      className: monte_iberia_eleuth,
      method: african_tree_toad,
      packageScheme: frilled_lizard1588.scheme,
      package: river_turtle,
      packagePath: bonobo,
      line: shrimp.group(4) == null ? -1 : int.parse(shrimp.group(4)!),
      column: shrimp.group(5) == null ? -1 : int.parse(shrimp.group(5)!),
      isConstructor: basset_fauve_de_bretagne,
      source: scorpion_fish,
    );
  }
}
